local _M = {_NAME = "somepackage", _TYPE = 'module'}

local panel = require "panel"
local button = require "panel.button"
local deckedit = require "ggdeckedit"
local game = require "gggame"
-------------------------------------------------------------------------

function _M:new(t)
	t=t or {}
	local menu = panel:new(t)
	menu.name = "Menu"
	menu.text = ""

	local start = button:new{x=(menu.width-75)/2, y=34, width=75, height=30}
	start.name = "Start"
	start.onclick = function(self)
		self.parent:close()
		ui:add(gggame:new{width=ui.width, height=ui.height, playerdeck = menu.deck})
	end
	menu:add(start)

	local deck = button:new{x=(menu.width-75)/2, y=68, width=75, height=30}
	deck.name = "Deck"
	deck.onclick = function(self)
		local dedit = deckedit:new{x=ui.width*.1, y=ui.height*.1, width=ui.width*.8, height=ui.height*.8}
		function dedit:onresult(r)
			menu.deck = r
		end
		ui:addModal(dedit)
	end
	menu:add(deck)

	local quit = button:new{x=(menu.width-75)/2, y=menu.height-34, width=75, height=30}
	quit.name = "Quit"
	quit.onclick = function(self)
		self.parent:close()
		love.event.push"q"
	end
	menu:add(quit)

	return menu	
end

-------------------------------------------------------------------------
if _VERSION == "Lua 5.1" then _G[_M._NAME] = _M end

return _M

