local _M = {_NAME = "ggstatusicon", _TYPE = 'module'}

local adds = require "adds"
-------------------------------------------------------------------------
local gg_mt = {__index = _M}
local panel_mt = {__index=panel}
setmetatable(_M, panel_mt)

local function iconmult(n)
	if n <= 0 then return 1
	elseif n == 1 then return 2
	elseif n <= 4 then return 3
	elseif n <= 8 then return 4
	elseif n <= 16 then return 5
	elseif n <= 32 then return 6
	else return 7 -- n > 32
	end
end

function _M:new(t)
	local ip = panel:new(t)
	assert(t.icons, "Must be given a valid iconset")
	setmetatable(ip, gg_mt)
	ip.name = "iconpanel"..tostring(ip.id)
	ip.icon = t.icons
	ip.font = t.height *.4
	ip.align = 'center' tmp.valign = 'middle'
	ip.number = 0
	ip.color_fg = {255,255,255}

	return ip
end

function _M.ondraw(self)
	local lg = love.graphics
	local im = self.icon[iconmult(self.number)]
	assert(im)
	im = imgs[im]
	assert(im)
	local s = self.height / im:getHeight()
	lg.setColor(255,255,255)
	lg.draw(im, 0, 0, 0, s)
	lg.setFont(fonts[self.font])

	if not (self.nonumber or self.number == 1 or self.number == 0) then
		lg.setColor(0,0,0)
		lg.printf(self.number, 1, (self.height/2)+1, self.width-2, 'center')
		lg.printf(self.number, -1, (self.height/2)-1, self.width-2, 'center')
		lg.setColor(self.color_fg)
		lg.printf(self.number, 0, (self.height/2), self.width-2, 'center')
	end

end

function _M:onupdate()
	local info = self.info
	if info then
		if not info.oldname then
			info.oldname = info.name or self.name
		end
		info.name = info.oldname .. ": " .. self.number
	end
end


-------------------------------------------------------------------------
if _VERSION == "Lua 5.1" then _G[_M._NAME] = _M end

return _M

