
require "adds"
require "utils"
--local util = require "panel.util"
local panel = require "panel"
local button = require "panel.button"
local ggplayerstatus = require "ggplayerstatus"
local about = require "panel.about"
local ggfinale = require "ggfinale"
local deck = require "deck"
local player = require "player"
local ggmmenu = require "ggmmenu"

function love.load()
	love.graphics.setIcon(imgs['icon'])

	-- if theres no makefile, then we're probably running as release.
	__DEBUG = love.filesystem.exists('Makefile')
	
	if not __DEBUG then
		math.randomseed(os.time())
	end
	
	-- partly this is because I've heard some PRNGs need a few rounds to
	-- give decent numbers, but mostly its because I'm sick of seeing the 
	-- same card layout.
	for i=1,256 do math.random() end 

	ui = panel:new{width=800, height=600}
	ui.name, ui.text = "Root Panel", ""
	ui.background = imgs["bg"]
	
	local mmenu = ggmmenu:new{x=ui.width*.1, y=ui.height*.1, width=ui.width*.3, height=ui.height*.8;
	color_fg = {0,0,0}, color_bg = {0,0,0,127}}
	ui:add(mmenu)
		
	if not introduced then
		introduced = true
		about = about:new{x=50, y=50, width=ui.width-100, height=ui.height-100;
		title = "Welcome to Gangrene", text=love.filesystem.read"README"}
		ui:addModal(about)
	end

end

function love.draw()
	local sh, sw = love.graphics.getHeight(), love.graphics.getWidth()
	love.graphics.reset()
	love.graphics.setColorMode('replace')

	ui:draw()
	
	local x, y = love.mouse.getPosition()
	
	local t = ui:hover(x, y)
	if t and t.info then
		t:infobox(x, y)
	end
end

function love.update(dt)
	love.timer.sleep(0)
	ui:update(dt)
end

function love.keyreleased(k)
	ui:keyreleased(k)

	if k == 'q' or k == 'esc' then
		love.event.push('q')
	end
end

function love.keypressed(k, u)
	ui:keypressed(k, u)
end

function love.mousepressed(x, y, btn)
	ui:mousepressed(x, y, btn)
end

function love.mousereleased(x, y, btn)
	ui:mousereleased(x, y, btn)
end
