local _M = {_NAME = "about", _TYPE = 'module'}

local panel = require "panel"
local util = require "panel.util"
-------------------------------------------------------------------------


function _M:new(t)
	local about = panel:new(t)
	about.name = "about"
	
	local function onclick()
		about.active = false
		about:close()
	end
	about.onclick = onclick
	about.color_bg = t.color_bg or util.color(.6,.4,.1)
	about.color_fg = t.color_fg or util.color(.0,.0,.0)
	about.name = "About"
	about.text = ""
		
	tmp = panel:new{x=1, y=1, width=about.width-2, height=49}
	tmp.name = "label"
	tmp.font = 24
	tmp.text = t.title or "Welcome"
	tmp.color_bg = about.color_bg
	tmp.color_fg = about.color_fg
	tmp.align = 'center'
	tmp.border = false
	tmp.onclick = about.onclick
	about:add(tmp)

	tmp = panel:new{x=50, y=50, width=about.width-101, height=about.height-101}
	tmp.name = "text"
	tmp.font = 12
	tmp.color_bg = util.color(.0,.0,.0)
	tmp.color_fg = util.color(1.0,1.0,1.0)
	tmp.align = 'left'
	tmp.valign = 'top'
	tmp.border = false
	tmp.onclick = about.onclick
	tmp.text = t.text or love.filesystem.read('README')

	about:add(tmp)

	return about
end

-------------------------------------------------------------------------
if _VERSION == "Lua 5.1" then _G[_M._NAME] = _M end

return _M

