-------------------------------------------------------------------------
-- [spin.lua]
-- panel.spin
-------------------------------------------------------------------------
-- Copyright (C) Textmode DMB 2011
-------------------------------------------------------------------------
local _M = {_NAME = "textbox", _TYPE = 'module'}

local panel = require "panel"
local button = require "panel.button"
-------------------------------------------------------------------------

local spin_mt = {__index=_M}
local panel_mt = {__index=panel}
setmetatable(_M, panel_mt)

local function modvalue(self, x, y, btn)
	local p = self.parent
	
	p.value = p.value + (self.mod*p.increment)
end

function _M:new(t)
	local s = panel:new(t)
	setmetatable(s, spin_mt)
	
	s.name = "spinner#"..s.id
	s.text = ""
	s.value = t.value or 0
	s.increment = t.increment or 1
	s.btn_up   = button:new{name="spinup",   text="^", x=0, y=0, width=s.width, height=s.height/2;
	color_fg = s.color_fg, color_bg = s.color_bg, font=s.font}
	s.btn_up.mod = 1
	s.btn_up.onclick = modvalue
	s.btn_down = button:new{name="spindown", text="v", x=0, y=s.height/2, width=s.width, height=s.height/2;
	color_fg = s.color_fg, color_bg = s.color_bg, font=s.font}
	s.btn_down.mod = -1
	s.btn_down.onclick = modvalue
	
	s:add(s.btn_up)
	s:add(s.btn_down)
	
	assert(s.value)
	return s
end

-------------------------------------------------------------------------
if _VERSION == "Lua 5.1" then _G[_M._NAME] = _M end

return _M

