local _M = {_NAME='card', _TYPE='module'}
-------------------------------------------------------------------------

local mt = {__index=_M}

function _M:new(thing)
	local t = {}
	setmetatable(t, mt)
	thing = thing or {}
	assert(type(thing) == 'table', "Initializer must be a valid table, or nil.")
	
	t._TYPE = 'thing'
	t.name        = thing.name or "New Thing"
	t.desc        = thing.desc or ""
	t.tags        = thing.tags or {}

	t.onDestroy   = thing.onDestroy
	
	return t
end

function _M.event(thing, event, ...)
	local eventer = string.format("on%s", event)
	if thing[eventer] then
		return thing[eventer](thing, event, ...)
	else
		return false, "No handler"
	end
end

function _M:Destroy(...)
	return self:event('Destroy', ...)
end
-------------------------------------------------------------------------
if _VERSION == "Lua 5.1" then _G[_M._NAME] = _M end

return _M
